package tests;

import static org.junit.Assert.*;

import org.junit.Test;

import implementation.*;

public class TestPoint {

	@Test
	public void testDefaultPointConstructor() {
		Point p = new Point();
		double xOfp = p.x;
		double yOfp = p.y;
		assertTrue(xOfp == 0 && yOfp == 0);
	}
	
	@Test
	public void testInitialzingXandY() {
		Point p1; // Declare a variable p that stores the address of some Point object.
		p1 = new Point(3, 4);
		assertTrue(p1.x == 3 && p1.y == 4);
		Point p2;
		p2 = new Point(6, 8);
		assertTrue(p2.x == 6 && p2.y == 8);
		
	}
	
	@Test
	public void testQuiz() {
		Point p1 = new Point(3, 4);
		Point p2 = new Point(3, 4);
		
		assertTrue(p1.x == p2.x && p1.y == p2.y);
		assertFalse(p1 == p2);
		
		p1 = p2;
		assertTrue(p1.x == p2.x && p1.y == p2.y);
		assertTrue(p1 == p2);
		
		p1.x = 6;
		assertTrue(p2.x == 6);
	} 
	
	@Test
	public void testMov() {
		Point p1 = new Point(3, 4);
		assertTrue(p1.x == 3 && p1.y == 4);
		p1.move(3, -2);
		assertTrue(p1.x == 6 && p1.y == 2);
	}
	
	@Test
	public void testIsAtFirstQ() {
		Point p1 = new Point(3, 4);
		assertTrue(p1.isInFirstQ());
		Point p2 = new Point(-3, 4);
		assertFalse(p2.isInFirstQ());
	}
	
	@Test
	public void testDefaultEquals() {
		Point p1 = new Point(2, 3);
		Point p2 = new Point(2, 3);
		assertFalse(p1.equals(p2));
	}
	
	@Test
	public void testOverriddenEquals() {
		Point2 p1 = new Point2(2, 3);
		Point2 nullPoint = null;
		assertTrue(p1.equals(p1));
		assertFalse(p1.equals(null));
		String s = "(2, 3)";
		
		// p1.getClass() will give to you Point2
		// s.getClass() will give to you String
		assertFalse(p1.equals(s));
		assertFalse(p1.equals(nullPoint));
		
		Point2 p2 = new Point2(2, 3);
		assertTrue(p1.equals(p2));
		Point2 p3 = new Point2(4, 6);
		assertFalse(p1.equals(p3));
	}
}









